function PVPSound_OnLoad()
	frame:RegisterEvent("PLAYER_ENTERING_WORLD");
	frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	frame:RegisterEvent("PLAYER_DEAD");	
	frame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	frame:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");
	frame:RegisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE");
	frame:RegisterEvent("CHAT_MSG_BG_SYSTEM_HORDE");
	frame:RegisterEvent("CHAT_MSG_MONSTER_YELL");

	 -- Slash Commands
	SlashCmdList["PVPSound"] = PVPSound_Command;
	SLASH_PVPSound1 = "/pvpsound";
	SLASH_PVPSound2 = "/ps";
end

	frame = CreateFrame("FRAME", "PVPSound_Frame");
	local PS_timer_reset = false;
	local PS_reset_time = 1800;
	local PS_mkill_time = 60;
	local PS_showemote = true;
	local PS_pvpmode = true;
	local PS_kills = 0;
	local myfaction = "Not Yet";
	local AllianceStatus = "Not Yet";
	local HordeStatus = "Not Yet";
	local SotaAttacker = "Not Yet";
	local SotaAttackerYell = "Not Yet";
	local msg = "%s %s"

	local ABobjectives = {Farm = 0,	GoldMine = 0, LumberMill = 0, Stables = 0, Blacksmith = 0}

	local function ABget_objective(id)
		if id >=16 and id <=20 then return "GoldMine"
		elseif id >= 21 and id <= 25 then return "LumberMill"
		elseif id >= 26 and id <= 30 then return "Blacksmith"
		elseif id >= 31 and id <= 35 then return "Farm"
		elseif id >= 36 and id <= 40 then return "Stables"
		else return false
		end
	end

	local function ABobj_state(id)
		if id == 18 or id == 23 or id == 28 or id == 33 or id == 38 then
		return 1 -- Alliance
		elseif id == 20 or id == 25 or id == 30 or id == 35 or id == 40 then
		return 2 -- Horde
		elseif id == 17 or id == 22 or id == 27 or id == 32 or id == 37 then
		return 3 -- Alliance trys to capture from Horde
		elseif id == 19 or id == 24 or id == 29 or id == 34 or id == 39 then
		return 4 -- Horde trys to capture from Alliance
		else return 0 -- Noone controling
		end
	end

	local TBFGobjectives = {Lighthouse = 0,	Mines = 0, Waterworks = 0}
	
	local function TBFGget_objective(id)
		if id >=6 and id <=12 then return "Lighthouse"
		elseif id >= 16 and id <= 20 then return "Mines"
		elseif id >= 26 and id <= 30 then return "Waterworks"
		else return false
		end
	end

	local function TBFGobj_state(id)
		if id == 11 or id == 18 or id == 28 then
		return 1 -- Alliance
		elseif id == 10 or id == 20 or id == 30 then
		return 2 -- Horde
		elseif id == 9 or id == 17 or id == 27 then
		return 3 -- Alliance trys to capture from Horde
		elseif id == 12 or id == 19 or id == 29 then
		return 4 -- Horde trys to capture from Alliance
		else return 0 -- Noone controling
		end
	end

	local IOCobjectives = {Quarry = 0, Workshop = 0, Hangar = 0, Docks = 0, Refinerie = 0}

	local function IOCget_objective(id)
		if id >= 16 and id <= 20 then return "Quarry"
		elseif id >= 135 and id <= 139 then return "Workshop"
		elseif id >= 140 and id <= 144 then return "Hangar"
		elseif id >= 145 and id <= 149 then return "Docks"
		elseif id >= 150 and id <= 154 then return "Refinerie"
		elseif id >= 9 and id <= 12	then return "Keep"
		else return false
		end
	end

	local function IOCobj_state(id)
		if id == 18 or id == 136 or id == 141 or id == 146 or id == 151 then
		return 1 -- Alliance
		elseif id == 20 or id == 138 or id == 143 or id == 148 or id == 153 then
		return 2 -- Horde	
		elseif id == 17 or id == 137 or id == 142 or id == 147 or id == 152 then
		return 3 -- Alliance trys to capture from Horde
		elseif id == 19 or id == 139 or id == 144 or id == 149 or id == 154 then
		return 4 -- Horde trys to capture from Alliance
		else return 0 -- Noone controling
		end
	end
	
	local SOTAobjectives = {}

	local function SOTAget_objective(id)
		if id >= 13 and id <= 15 then return "South_Graveyard"
		elseif id >= 46 and id <= 46 then return "The Frostbreaker"
		elseif id >= 48 and id <= 48 then return "The Blightbringer"
		elseif id >= 77 and id <= 79 then return "Gate of the Red Sun"
		elseif id >= 80 and id <= 82 then return "Gate of the Blue Sapphire"
		elseif id >= 102 and id <= 104	then return "Gate of the Yellow Moon"
		elseif id >= 105 and id <= 107	then return "Gate of the Purple Amethyst"
		elseif id >= 108 and id <= 110	then return "Gate of the Green Emerald"
		else return false
		end
	end

	local function SOTAobj_state(id)
		if id == 15 then
		return 1 -- Alliance
		elseif id == 13 then
		return 2 -- Horde
		elseif id == 46 then
		return 3 -- Alliance attacking
		elseif id == 48 then
		return 4 -- Horde attacking
		else return 0 -- Noone controling
		end
	end

function PVPSound_OnEvent(self, event, ...)
	local player = UnitGUID("player")
	local arg1, eventType, srcGUID, srcName, _, _, dstName, dstFlags  = select(1, ...)
	local CombatLog_Object_IsA = CombatLog_Object_IsA
	local COMBATLOG_OBJECT_NONE = COMBATLOG_OBJECT_NONE
	local PS_COMBATLOG_FILTER_ENEMY_PLAYERS = bit.bor (COMBATLOG_OBJECT_AFFILIATION_MASK,COMBATLOG_OBJECT_REACTION_MASK,COMBATLOG_OBJECT_CONTROL_PLAYER,COMBATLOG_OBJECT_TYPE_PLAYER);
	local PS_COMBATLOG_FILTER_ENEMY_NPC = bit.bor (COMBATLOG_OBJECT_AFFILIATION_MASK,COMBATLOG_OBJECT_REACTION_MASK,COMBATLOG_OBJECT_CONTROL_PLAYER,COMBATLOG_OBJECT_TYPE_PLAYER,COMBATLOG_OBJECT_CONTROL_NPC,COMBATLOG_OBJECT_TYPE_NPC);
	local PS_msg = "";

	Winner = "";
	GameWinner = "";
	WinAnnounce = "";

	CurrentZone = GetRealZoneText();
	if CurrentZone == BG_WSG  then
		MyZone = "Zone_WarsongGulch";
	elseif CurrentZone == BG_AB then
		MyZone = "Zone_ArathiBasin";
	elseif CurrentZone == BG_AV then
		MyZone = "Zone_AlteracValley";
	elseif CurrentZone == BG_EOTS then
		MyZone = "Zone_EyeoftheStorm";
	elseif CurrentZone == BG_IOC then
		MyZone = "Zone_IsleofConquest";
	elseif CurrentZone == BG_SOTA then
		MyZone = "Zone_StrandoftheAncients";
	elseif CurrentZone == BG_TP then
		MyZone = "Zone_TwinPeaks";
	elseif CurrentZone == BG_TBFG then
		MyZone = "Zone_TheBattleforGilneas";
	end

	if event == "PLAYER_ENTERING_WORLD" then
		myfaction = UnitFactionGroup("player");
	end
	
	if event == "PLAYER_DEAD" then
		PS_timer_reset = true;
	end

	if event == "ZONE_CHANGED_NEW_AREA" then
		local PS_zone = GetRealZoneText();
		if  	(PS_zone == BG_WSG or PS_zone == BG_EOTS or PS_zone == BG_AB or PS_zone == BG_AV or PS_zone == BG_IOC or PS_zone == BG_SOTA or PS_zone == BG_TP or PS_zone == BG_TBFG) and (myfaction == "Horde") then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\GameStatus\\PlayRed.mp3");
		elseif (PS_zone == BG_WSG or PS_zone == BG_EOTS or PS_zone == BG_AB or PS_zone == BG_AV or PS_zone == BG_IOC or PS_zone == BG_SOTA or PS_zone == BG_TP or PS_zone == BG_TBFG) and (myfaction == "Alliance") then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\GameStatus\\PlayBlue.mp3");
		elseif (PS_zone == AR_ROL or PS_zone == AR_BEA or PS_zone == AR_NA or PS_zone == AR_DA or PS_zone == AR_TROV) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\GameStatus\\PrepareForBattle.mp3");
		end
		PS_timer_reset = true;
	end

	if (event == "CHAT_MSG_BG_SYSTEM_NEUTRAL") then
		if (strfind(arg1,BG_ALLIANCE_WINS)) then
			Winner = "Alliance";
			WinAnnounce = "Yes";
		elseif (strfind(arg1,BG_HORDE_WINS)) then
			Winner = "Horde";
			WinAnnounce = "Yes";
		 -- Waronsg Gulch and Twin Peaks
		elseif (strfind(arg1,BG_VULNERABLE)) then
			if (MyZone == "Zone_WarsongGulch"  or MyZone == "Zone_TwinPeaks") then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\Overtime.mp3");
			end
		 -- Strand of the Ancients
		elseif (strfind(arg1,BG_SOTA_ROUND_ONE)) or (strfind(arg1,BG_SOTA_ROUND_TWO)) then
			if (MyZone == "Zone_StrandoftheAncients") then
				for i=10, 10, 1 do
					local name, _, textureIndex = GetMapLandmarkInfo(i)
					if name and textureIndex then
						if (name == "The Frostbreaker") then
							SOTAobjectives = {South_Graveyard = 2}
							SotaAttacker = "Alliance"
						elseif (name == "The Blightbringer") then
							SOTAobjectives = {South_Graveyard = 1}
							SotaAttacker = "Horde"
						end
					end
				end

				if (SotaAttacker == "Alliance" and (myfaction == "Alliance")) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\AttackTheEnemyCore.mp3");
				elseif (SotaAttacker == "Alliance" and (myfaction == "Horde")) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\DefendYourCore.mp3");
				elseif (SotaAttacker == "Horde" and (myfaction == "Alliance")) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\DefendYourCore.mp3");
				elseif (SotaAttacker == "Horde" and (myfaction == "Horde")) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\AttackTheEnemyCore.mp3");
				end
			end
		end

		if (WinAnnounce == "Yes") then
			if (myfaction == Winner) then
				GameWinner = "Us";
			else
				GameWinner = "Them";
			end

			if (GameWinner == "Us") then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\GameStatus\\"..Winner.."_Wins.mp3");
			elseif (GameWinner == "Them") then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\GameStatus\\"..Winner.."_Wins.mp3");
			end
		end

	elseif (event == "CHAT_MSG_BG_SYSTEM_ALLIANCE" or event == "CHAT_MSG_BG_SYSTEM_HORDE") then
		 -- Waronsg Gulch and Twin Peaks
		if (strfind(arg1,BG_ALLIANCE_WINS)) then
			Winner = "Alliance";
			WinAnnounce = "Yes";
		elseif (strfind(arg1,BG_HORDE_WINS)) then
			Winner = "Horde";
			WinAnnounce = "Yes";
		elseif (strfind(arg1,BG_PICKED)) then
			if (MyZone == "Zone_WarsongGulch" or MyZone == "Zone_TwinPeaks") then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Flag_Taken.mp3");
			end
		elseif (strfind(arg1,BG_DROPPED)) then
			if (MyZone == "Zone_WarsongGulch" or MyZone == "Zone_TwinPeaks") then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Flag_Dropped.mp3");
			end
		elseif (strfind(arg1,BG_RETURNED)) then
			if (MyZone == "Zone_WarsongGulch" or MyZone == "Zone_TwinPeaks") then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Flag_Returned.mp3");
			end
		elseif (strfind(arg1,BG_CAPTURED)) then
			if (MyZone == "Zone_WarsongGulch" or MyZone == "Zone_TwinPeaks") then
				_, _, AllianceScore = GetWorldStateUIInfo(2); -- Alliance score
				_, _, HordeScore = GetWorldStateUIInfo(3); -- Horde score
				if (AllianceScore == "1/3") and (HordeScore == "0/3") then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Takes_Lead.mp3");
				elseif (AllianceScore == "0/3") and (HordeScore == "1/3") then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Takes_Lead.mp3");
				elseif (AllianceScore == "2/3") and (HordeScore == "1/3") then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Score.mp3");
				elseif (AllianceScore == "1/3") and (HordeScore == "2/3") then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Score.mp3");
				elseif (AllianceScore == "1/3") and (HordeScore == "1/3") then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Score.mp3");
				elseif (AllianceScore == "2/3") and (HordeScore == "2/3") then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Score.mp3");
				elseif (AllianceScore == "0/3") and (HordeScore == "2/3") then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Inc_Lead.mp3");
				elseif (AllianceScore == "2/3") and (HordeScore == "0/3") then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Inc_Lead.mp3");
				end
			end

		 -- Eye of the Storm
		elseif (strfind(arg1,BG_EOTS_CONTROL)) then
			if (MyZone == "Zone_EyeoftheStorm") then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Defence.mp3");
			end
		elseif (strfind(arg1,BG_EOTS_LOST_CONTROL)) then
			if (MyZone == "Zone_EyeoftheStorm") then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Offence.mp3");
			end
		 -- Isle of Conquest
		elseif (strfind(arg1,BG_IOC_GATE_DOWN)) then
			if (MyZone == "Zone_IsleofConquest") then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\"..event.."_Vulnerable.mp3");
			end
		end

		if (WinAnnounce == "Yes") then
			if (myfaction == Winner) then
				GameWinner = "Us";
			else
				GameWinner = "Them";
			end

			if (GameWinner == "Us") then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\GameStatus\\"..Winner.."_Wins.mp3");
			elseif (GameWinner == "Them") then
				PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\GameStatus\\"..Winner.."_Wins.mp3");
			end
		end

	 -- Alterac Valley
	elseif (event == "CHAT_MSG_MONSTER_YELL") then
		if (MyZone == "Zone_AlteracValley") then
			if (strfind(arg1,BG_HASDESTROYED)) then
				if (strfind(arg1,FACTION_HORDE)) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Destroyed.mp3");
				elseif (strfind(arg1,FACTION_ALLIANCE)) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Destroyed.mp3");
				end

			elseif (strfind(arg1,BG_HASTAKEN) or strfind(arg1,BG_TAKEN)) then
				if (strfind(arg1,FACTION_HORDE)) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3");
				elseif (strfind(arg1,FACTION_ALLIANCE)) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3");
				end

			elseif (strfind(arg1,BG_WILLDESTROYIT) or strfind(arg1,BG_WILLCAPTUREIT)) then
				if (strfind(arg1,FACTION_HORDE)) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Offense.mp3");
				elseif (strfind(arg1,FACTION_ALLIANCE)) then
					PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Offense.mp3");
				end

			elseif (strfind(arg1,BG_WINS)) then
					if (strfind(arg1,FACTION_HORDE)) then
						Winner = "Horde";
						WinAnnounce = "Yes";
					elseif (strfind(arg1,FACTION_ALLIANCE)) then
						Winner = "Alliance";
						WinAnnounce = "Yes";
					end
				if (WinAnnounce == "Yes") then
					if (myfaction == Winner) then
						GameWinner = "Us";
					else
						GameWinner = "Them";
					end

					if (GameWinner == "Us") then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\GameStatus\\"..Winner.."_Wins.mp3");
						DEFAULT_CHAT_FRAME:AddMessage(anum);
						DEFAULT_CHAT_FRAME:AddMessage(ascore);
						DEFAULT_CHAT_FRAME:AddMessage(hnum);
						DEFAULT_CHAT_FRAME:AddMessage(hscore);
					elseif (GameWinner == "Them") then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\GameStatus\\"..Winner.."_Wins.wav");
						DEFAULT_CHAT_FRAME:AddMessage(mAllyInfo);
						DEFAULT_CHAT_FRAME:AddMessage(mHordeInfo);
					end
				end
			end
		end
		 -- Strand of the Ancients
		if (MyZone == "Zone_StrandoftheAncients") then
			for i=10, 10, 1 do
				local name, _, textureIndex = GetMapLandmarkInfo(i)
				if name and textureIndex then
					if (name == "The Frostbreaker") then
						SotaAttackerYell = "Alliance"
					elseif (name == "The Blightbringer") then
						SotaAttackerYell = "Horde"
					end
				end
			end

			if (strfind(arg1,BG_SOTA_VEHICLE_EAST)) then
				if (SotaAttackerYell == "Alliance") then
					local name, _, textureIndex = GetMapLandmarkInfo(2)
					if name and textureIndex then
						if ((textureIndex == 15) and (name == "East Graveyard") and (SotaAttackerYell == "Alliance")) then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3");
						end
					end
				elseif (SotaAttackerYell == "Horde") then
					local name, _, textureIndex = GetMapLandmarkInfo(3)
					if name and textureIndex then
						if ((textureIndex == 13) and (name == "East Graveyard") and (SotaAttackerYell == "Horde")) then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3");
						end
					end
				end
			elseif (strfind(arg1,BG_SOTA_VEHICLE_WEST)) then
				if (SotaAttackerYell == "Alliance") then
					local name, _, textureIndex = GetMapLandmarkInfo(12)
					if name and textureIndex then
						if ((textureIndex == 15) and (name == "West Graveyard") and (SotaAttackerYell == "Alliance")) then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3");
						end
					end
				elseif (SotaAttackerYell == "Horde") then
					local name, _, textureIndex = GetMapLandmarkInfo(12)
					if name and textureIndex then
						if ((textureIndex == 13) and (name == "West Graveyard") and (SotaAttackerYell == "Horde")) then
							PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3");
						end
					end
				end
			end
		end
	end

	 -- Arathi Basin
	if (MyZone == "Zone_ArathiBasin") then
		for i=1, GetNumMapLandmarks(), 1 do
			local name, _, textureIndex = GetMapLandmarkInfo(i)
			if name and textureIndex then
				local typ = ABget_objective(textureIndex)
				if typ then
					if ABobj_state(ABobjectives[typ]) == 0 and ABobj_state(textureIndex) > 2 then
					elseif ABobj_state(ABobjectives[typ]) == 1 and ABobj_state(textureIndex) == 4 then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\CHAT_MSG_BG_SYSTEM_HORDE_Offence.mp3");
					elseif ABobj_state(ABobjectives[typ]) == 2 and ABobj_state(textureIndex) == 3 then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\CHAT_MSG_BG_SYSTEM_ALLIANCE_Offence.mp3");
					elseif ABobj_state(ABobjectives[typ]) == 3 and ABobj_state(textureIndex) == 4 then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\CHAT_MSG_BG_SYSTEM_HORDE_Offence.mp3");
					elseif ABobj_state(ABobjectives[typ]) == 4 and ABobj_state(textureIndex) == 3 then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\CHAT_MSG_BG_SYSTEM_ALLIANCE_Offence.mp3");
					elseif ABobj_state(ABobjectives[typ]) == 3 and ABobj_state(textureIndex) == 1 then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\CHAT_MSG_BG_SYSTEM_ALLIANCE_Defence.mp3");
					elseif ABobj_state(ABobjectives[typ]) == 4 and ABobj_state(textureIndex) == 2 then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\CHAT_MSG_BG_SYSTEM_HORDE_Defence.mp3");
					end
					ABobjectives[typ] = textureIndex
				end
			end
		end
	end

	 -- The Battle for Gilneas
	if (MyZone == "Zone_TheBattleforGilneas") then
		for i=1, GetNumMapLandmarks(), 1 do
			local name, _, textureIndex = GetMapLandmarkInfo(i)
			if name and textureIndex then
				local typ = TBFGget_objective(textureIndex)
				if typ then
					if TBFGobj_state(TBFGobjectives[typ]) == 0 and TBFGobj_state(textureIndex) > 2 then
					elseif TBFGobj_state(TBFGobjectives[typ]) == 1 and TBFGobj_state(textureIndex) == 4 then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\CHAT_MSG_BG_SYSTEM_HORDE_Offence.mp3");
					elseif TBFGobj_state(TBFGobjectives[typ]) == 2 and TBFGobj_state(textureIndex) == 3 then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\CHAT_MSG_BG_SYSTEM_ALLIANCE_Offence.mp3");
					elseif TBFGobj_state(TBFGobjectives[typ]) == 3 and TBFGobj_state(textureIndex) == 4 then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\CHAT_MSG_BG_SYSTEM_HORDE_Offence.mp3");
					elseif TBFGobj_state(TBFGobjectives[typ]) == 4 and TBFGobj_state(textureIndex) == 3 then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\CHAT_MSG_BG_SYSTEM_ALLIANCE_Offence.mp3");
					elseif TBFGobj_state(TBFGobjectives[typ]) == 3 and TBFGobj_state(textureIndex) == 1 then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\CHAT_MSG_BG_SYSTEM_ALLIANCE_Defence.mp3");
					elseif TBFGobj_state(TBFGobjectives[typ]) == 4 and TBFGobj_state(textureIndex) == 2 then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\CHAT_MSG_BG_SYSTEM_HORDE_Defence.mp3");
					end
					TBFGobjectives[typ] = textureIndex
				end
			end
		end
	end
	 -- Strand of the Ancients, South Graveyard
	if (MyZone == "Zone_StrandoftheAncients") then
		for i=9, 9, 1 do
			local name, _, textureIndex = GetMapLandmarkInfo(i)
			if name and textureIndex then
				local typ = SOTAget_objective(textureIndex)
				if typ then
					if (SOTAobj_state(SOTAobjectives[typ]) == 2 and SOTAobj_state(textureIndex) == 1 and (name == "South Graveyard")  and (SotaAttacker == "Alliance")) then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\ALLIANCE_Defence.mp3");
					elseif (SOTAobj_state(SOTAobjectives[typ]) == 1 and SOTAobj_state(textureIndex) == 2 and (name == "South Graveyard") and (SotaAttacker == "Horde")) then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\HORDE_Defence.mp3");
					end
					SOTAobjectives[typ] = textureIndex
				end
			end
		end
	end
	 -- Isle of Conquest
	if (MyZone == "Zone_IsleofConquest") then
		_, _, AllianceStatus = GetWorldStateUIInfo(1); -- Alliance sscore
		_, _, HordeStatus = GetWorldStateUIInfo(2); -- Horde score
		for i=1, GetNumMapLandmarks(), 1 do
			local name, _, textureIndex = GetMapLandmarkInfo(i)
			if name and textureIndex then
				local typ = IOCget_objective(textureIndex)
				if typ then
					if IOCobj_state(IOCobjectives[typ]) == 0 and IOCobj_state(textureIndex) > 2 then
					elseif IOCobj_state(IOCobjectives[typ]) == 1 and IOCobj_state(textureIndex) == 4 then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\CHAT_MSG_BG_SYSTEM_HORDE_Offence.mp3");
					elseif IOCobj_state(IOCobjectives[typ]) == 2 and IOCobj_state(textureIndex) == 3 then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\CHAT_MSG_BG_SYSTEM_ALLIANCE_Offence.mp3");
					elseif IOCobj_state(IOCobjectives[typ]) == 3 and IOCobj_state(textureIndex) == 4 then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\CHAT_MSG_BG_SYSTEM_HORDE_Offence.mp3");
					elseif IOCobj_state(IOCobjectives[typ]) == 4 and IOCobj_state(textureIndex) == 3 then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\CHAT_MSG_BG_SYSTEM_ALLIANCE_Offence.mp3");
					elseif IOCobj_state(IOCobjectives[typ]) == 3 and IOCobj_state(textureIndex) == 1 then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\CHAT_MSG_BG_SYSTEM_ALLIANCE_Defence.mp3");
					elseif IOCobj_state(IOCobjectives[typ]) == 4 and IOCobj_state(textureIndex) == 2 then
						PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\"..MyZone.."\\CHAT_MSG_BG_SYSTEM_HORDE_Defence.mp3");
					end
					IOCobjectives[typ] = textureIndex
				end
			end
		end
		if (HordeScore == "10") and (myfaction == "Alliance") then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\TenKillsRemains.mp3");
		elseif (AllianceScore == "10") and (myfaction == "Horde") then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\TenKillsRemains.mp3");
		elseif (HordeScore == "5") and (myfaction == "Alliance") then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\FiveKillsRemains.mp3");
		elseif (AllianceScore == "5") and (myfaction == "Horde") then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\FiveKillsRemains.mp3");
		elseif (HordeScore == "1") and (myfaction == "Alliance") then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\OneKillRemains.mp3");
		elseif (AllianceScore == "1") and (myfaction == "Horde") then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\OneKillRemains.mp3");
		end
	end

	 -- Alterac Valley
	if (MyZone == "Zone_AlteracValley") then
		_, _, AllianceStatus = GetWorldStateUIInfo(1); -- Alliance sscore
		_, _, HordeStatus = GetWorldStateUIInfo(2); -- Horde score
		if (HordeScore == "10") and (myfaction == "Alliance") then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\TenKillsRemains.mp3");
		elseif (AllianceScore == "10") and (myfaction == "Horde") then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\TenKillsRemains.mp3");
		elseif (HordeScore == "5") and (myfaction == "Alliance") then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\FiveKillsRemains.mp3");
		elseif (AllianceScore == "5") and (myfaction == "Horde") then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\FiveKillsRemains.mp3");
		elseif (HordeScore == "1") and (myfaction == "Alliance") then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\OneKillRemains.mp3");
		elseif (AllianceScore == "1") and (myfaction == "Horde") then
			PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\CountDown\\OneKillRemains.mp3");
		end
	end	

	 -- See if its to an enemy
	local toEnemy
	local toEnemyPlayer
	local toEnemyNPC
	if (dstName and not CombatLog_Object_IsA(dstFlags, COMBATLOG_OBJECT_NONE) ) then
		toEnemyPlayer = CombatLog_Object_IsA(dstFlags, PS_COMBATLOG_FILTER_ENEMY_PLAYERS)
		toEnemyNPC = CombatLog_Object_IsA(dstFlags, PS_COMBATLOG_FILTER_ENEMY_NPC)
	end

	if PS_pvpmode == true then
		toEnemy = toEnemyPlayer;
	else
		toEnemy = toEnemyNPC;
	end

	 -- If not from a event type we care about, then end
	if (eventType == "PARTY_KILL" and srcGUID == player and toEnemy ) then
		-- Killing
		if (not PS_lastkill or (GetTime() - PS_lastkill > PS_reset_time ) or PS_timer_reset) then
			PS_file = "First Blood.mp3";
			PS_msg = MSG_FirstBlood;
			PS_kills = 1;
			PS_mkills = 1;
			PS_timer_reset = false;
		elseif (GetTime() - PS_lastkill <= PS_reset_time ) then
			PS_kills = PS_kills + 1;
			 -- Multikilling
			if (GetTime() - PS_lastkill <= PS_mkill_time) then
				PS_firstmkill = PS_lastkill;
				if (GetTime() - PS_firstmkill <= PS_mkill_time) then
					PS_mkills = PS_mkills + 1;
					if (PS_mkills == 2) then
						PS_file = "Killing Spree.mp3";
						PS_msg = MSG_KillingSpree;
					elseif (PS_mkills == 3) then
						PS_file = "Rampage.mp3";
						PS_msg = MSG_Rampage;
					elseif (PS_mkills == 4) then
						PS_file = "Dominating.mp3";
						PS_msg = MSG_Dominating;
					elseif (PS_mkills == 5) then
						PS_file = "Unstoppable.mp3";
						PS_msg = MSG_Unstopable;
					elseif (PS_mkills == 6) then
						PS_file = "Godlike.mp3";
						PS_msg = MSG_Godlike;
					elseif (PS_mkills > 6) then
						PS_file = "Massacre.mp3";
						PS_msg = MSG_Massacre;
					end
				end
			end
		end
		PlaySoundFile("Interface\\AddOns\\PVPSound\\Sounds\\Spree\\"..PS_file);
		if PS_mkills >= 1000 then
			PS_mkills_msg = "[x" .. PS_mkills .. "]";
		else
			PS_mkills_msg = "";
		end
		if PS_showemote == true then
			SendChatMessage(PS_msg .. PS_mkills_msg, "EMOTE");
		elseif ( PS_showemote == false and PS_kills ~= 1 ) then
			DEFAULT_CHAT_FRAME:AddMessage(srcName .." " ..PS_msg..PS_mkills_msg,1,1,0);
		end
		PS_lastkill = GetTime();
	end
end

frame:SetScript("OnEvent", PVPSound_OnEvent);

function PVPSound_Command(arg1)
	arg1 = strlower(arg1)
	if arg1 == "emote" then
		PS_showemote = not PS_showemote;
		if PS_showemote == true then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_ShowEmote .. ": " .. Opt_Enable,1,1,0);
		else
			DEFAULT_CHAT_FRAME:AddMessage(Opt_ShowEmote .. ": " .. Opt_Disable,1,1,0);
		end
	elseif arg1 == "pvp" then
		PS_pvpmode = not PS_pvpmode;
		if PS_pvpmode == true then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_PVPMode,1,1,0);
		else
			DEFAULT_CHAT_FRAME:AddMessage(Opt_PVEMode,1,1,0);
		end
	elseif arg1 == "reset" then
		PS_timer_reset = true;
		DEFAULT_CHAT_FRAME:AddMessage(Opt_reset,1,1,0);
	elseif arg1 == "help" then
		DEFAULT_CHAT_FRAME:AddMessage("PVPSound v" .. GetAddOnMetadata("PVPSound", "Version") .. " " .. Opt_cmdlist,0,1,0);
		DEFAULT_CHAT_FRAME:AddMessage("/ps       ———>" .. Opt_helpstatus,1,1,0);
		DEFAULT_CHAT_FRAME:AddMessage("/ps PVP   ———>" .. Opt_helpmode,1,1,0);
		DEFAULT_CHAT_FRAME:AddMessage("/ps Emote ———>" .. Opt_helpshowemote,1,1,0);
		DEFAULT_CHAT_FRAME:AddMessage("/ps Reset ———>" .. Opt_helpreset,1,1,0);
		DEFAULT_CHAT_FRAME:AddMessage("/ps Help  ———>" .. Opt_helpcmdlist,1,1,0);
	else
		DEFAULT_CHAT_FRAME:AddMessage("PVPSound v" .. GetAddOnMetadata("PVPSound", "Version") .. " " .. Opt_helpinput,0,1,0);
		DEFAULT_CHAT_FRAME:AddMessage(Opt_kills .. ": "..PS_kills,1,1,0);
		if PS_pvpmode == true then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_PVPMode,1,1,0);
		else
			DEFAULT_CHAT_FRAME:AddMessage(Opt_PVEMode,1,1,0);
		end
		if PS_showemote == true then
			DEFAULT_CHAT_FRAME:AddMessage(Opt_ShowEmote .. ": " .. Opt_Enable,1,1,0);
		else
			DEFAULT_CHAT_FRAME:AddMessage(Opt_ShowEmote .. ": " .. Opt_Disable,1,1,0);
		end
	end
end